				org &4000
Music_Address			incbin "molusk.bin"

				org &7000
Player_Address			include "ArkosTrackerPlayer_SpectrumPentagon.asm"

; *** Interrupt Service Routine ************************************************

				org &8181
interruptServiceRoutine:
				; Save CPU context
				push af
				ex af,af'
				push af
				push bc
				push de
				push hl
				push ix
				push iy
				
				djnz $
				djnz $
				djnz $
				djnz $
				djnz $

				ld bc,&FE
				ld a,7
				out (c),a

				call Player_Address + 3
				
				ld bc,&FE
				ld a,0
				out (c),a
				
				; Restore CPU context
				pop iy
				pop ix
				pop hl
				pop de
				pop bc
				pop af
				ex af,af'
				pop af
				ei
				ret
				
; *** Initialization ***********************************************************

MAIN	; ZxSpin complains if MAIN symbol is missing. I should RTFM.

				di
				; Setup the vectorized interrupt mode
				ld hl,&8000	; HL point to the IM2 Lookup table
				ld a,h
				ld i,a		; Set I=&80
				im 2		; Switch to vectorized interrupts
				inc a
_im2_fill_lut			ld (hl),a	; Fill the IM2 LUT with &81
				inc l		; therefore, all INT will jump to &8181
				jr nz,_im2_fill_lut
				inc h
				ld (hl),a
				
				; Initialize CPU Stack
				ld l,h		; Set the CPU Stack at &8181
				ld sp,hl	; (right under the interrupt handler)

				ld de,Music_Address
				call Player_Address
				ei

MainLoop			halt
				jr MainLoop

