	
; 	Arkos Tracker - Player Test
;	MSX VER 0.01 BY WYZ



Music_Address		equ #4000
Music_SFX_Address	equ #D000

;INTERRUPT HANDLER (50/60 HZ)

HOOK            EQU     $FD9F


;SoundEffects equ 0				;If to 1, set it also PLY_UseSoundEffects to 1 in the player.


	org #8800

	di

		IN	A,[$A8]			;SELECT RAM PAGE 1
		LD	B,A			;PROVISIONAL *****
		RRCA
		RRCA
		AND	00001100B
		OR	B
		OUT	[$A8],A
		
		
		
		LD	HL,MODULE		;SET MODULE AT RIGHT ADDRESS
		LD	DE,Music_Address
		LD	BC,MODULE_END-MODULE
		LDIR

	ld 	de,Music_Address		;START! config module.
	call 	Player_Address
	

;SET INTERRUPT SERVICE IM1
		
                LD      HL,Player_Address + 3	;cont. playing at this address.
                LD      [HOOK+1],HL		
                LD      A,$C3			;jump at HOOK 1/50 or 1/60
                LD      [HOOK],A
                EI


MainLoop	JP	MainLoop		;can't go to basic. page 1 selected as RAM.
	



;FILES________________________

Player_Address	
		include "ArkosTrackerPlayer_CPC_MSX.asm"

MODULE		incbin "molusk.bin"		;include your module here.
MODULE_END	DB	0

